<?php
/**
* @version		$ 1.2 2009-10$
* @package		Joomla
* @subpackage	IPricecalc
* @copyright	Copyright (C) 2009 LoT studio group. All rights reserved.
* @license		The commercial licence http://www.lot-studio.ru/license-ipricecalc
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'tables'.DS.'discount.php');
require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'helpers'.DS.'html.php');
require_once(JPATH_COMPONENT.DS.'views'.DS.'discount.php');

class IPricecalcControllerDiscount extends JController
{
	/**
	 * Constructor
	 */
	function __construct( $config = array() )
	{
		parent::__construct( $config );
		// Register Extra tasks
		$this->registerTask( 'add',			'edit' );
		$this->registerTask( 'apply',		'save' );
		$this->registerTask( 'unpublish',	'publish' );
	}

	/**
	 * Display the list of banners
	 */
	function display()
	{
		global $mainframe;

		$db =& JFactory::getDBO();

		$context			= 'com_ipricecalc.discount';
		$table =& JTable::getInstance('Iprice_discount', 'JTable');
		
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order', 'filter_order', 'id',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir',	'', 'word' );
		$filter_state 		= $mainframe->getUserStateFromRequest( $context.'filter_state', 'filter_state', '', 'word' );
		$search			= $mainframe->getUserStateFromRequest( $context.'search', 'search', '',	'string' );
		$search			= JString::strtolower( $search );
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest($context.'.limitstart', 'limitstart', 0, 'int');
		
		$table->SetQuery($filter_state,$search, $filter_order, $filter_order_Dir);
		$total = $table->GetCount();

		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );

		$rows = $table->GetList($pageNav->limitstart, $pageNav->limit );

		// build list of categories
		$javascript = 'onchange="document.adminForm.submit();"';

		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );

		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;

		// search filter
		$lists['search']= $search;
		
		IPricecalcViewDiscount::discounts( $rows, $pageNav, $lists );		
	}

	function edit()
	{
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$edit = ($this->_task == 'edit');
		if ($edit) {
			$cid	= JRequest::getVar('cid', array(0), 'method', 'array');
			$cid	= array((int) $cid[0]);
		} else {
			$cid	= array( 0 );
		}
	
		$option = JRequest::getCmd('option');

		JArrayHelper::toInteger($cid, array(0));

		$row =& JTable::getInstance('Iprice_discount', 'JTable');
		// load the row from the db table
		$row->load( $cid[0] );

		if ($edit) {
			// do stuff for existing records
			$row->checkout($user->get('id'));
		} else {
			// do stuff for new records
		}
		$lists = array();

		// build the html select list for ordering

		$lists['published'] 		= JHTML::_('select.booleanlist',  'published', '', $row->published );
		$lists['type'] = JHTMLIpriceList::discount_type( "type", $row->type);
		$lists['kind'] = JHTMLIpriceList::discount_kind( "kind", $row->kind);

		// get params definitions
		IPricecalcViewDiscount::discount( $row, $lists);
	}

	/**
	 * Save method
	 */
	function save()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('Iprice_discount', 'JTable');
		$post = JRequest::get( 'post' );
	
		if (!$row->bind( $post )) {
			JError::raiseError(500, $row->getError() );
		}

		// save to a copy, reset the primary key
		if ($task == 'save2copy') {
			$row->id = 0;
		}

		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError() );
		}

		// if new item, order last in appropriate group
		if (!$row->id) {
		}

		// save the changes
		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();

		$task = JRequest::getCmd( 'task' );
	
		switch ($task)
		{
			case 'apply':
			case 'save2copy':
				$msg	= JText::sprintf( 'Changes to X saved', JText::_('Discount Item') );
				$link	= 'index.php?option=com_ipricecalc&c=discount&task=edit&cid[]='. $row->id .'';
				break;

			case 'save2new':
				$msg	= JText::sprintf( 'Changes to X saved', JText::_('Discount') );
				$link	= 'index.php?option=com_ipricecalc&c=discount&task=edit';
				break;

			case 'save':
			default:
				$msg	= JText::_( 'Discount item saved' );
				$link	= 'index.php?option=com_ipricecalc&c=discount';
				break;
		}


		$this->setRedirect( $link, $msg );
	}

	function cancel()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$this->setRedirect( 'index.php?option=com_ipricecalc&c=discount' );
		// Initialize variables
		$db =& JFactory::getDBO();
		$row =& JTable::getInstance('Iprice_discount', 'JTable');
		$row->bind( JRequest::get( 'post' ));
		$row->checkin();
	}


	function copy()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=discount' );
	}

	function publish()
	{
		global $mainframe;
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=discount' );
	// Initialize variables
		$db 	=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		$n			= count( $cid );
		
		if (empty( $cid )) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}
		JArrayHelper::toInteger($cid);
		$cids = implode( ',', $cid );
		
		$query = 'UPDATE #__iprice_discount'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '. $cids .' )'
		. ' AND ( checked_out = 0 OR ( checked_out = '. (int) $user->get('id') .' ) )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			JError::raiseError(500, $db->getErrorMsg() );
		}
		if (count( $cid ) == 1) {
			$row =& JTable::getInstance('Iprice_discount', 'JTable');
			$row->checkin( intval( $cid[0] ) );
		}
		$this->setMessage( JText::sprintf( $publish ? 'Items published' : 'Items unpublished', $n ) );		
	}

	function remove()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=discount' );

		// Initialize variables
		$db =& JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$n		= count( $cid );
		JArrayHelper::toInteger( $cid );

		if (count( $cid )) {
			$cids = implode( ',', $cid );

			$query = 'select count(*) from #__iprice_item WHERE discid IN ( '. $cids .' )';
			$db->setQuery( $query );
			$cnt = $db->loadResult();
			$query = 'select count(*) from #__iprice_sections WHERE discid IN ( '. $cids .' )';
			$db->setQuery( $query );
			$cnt =  $cnt + $db->loadResult();
			
			if ($cnt)
				return JError::raiseWarning( 500, JText::_( 'One or more items or sections has selected discount(s)' ) );

			$query = 'DELETE FROM #__iprice_discount'
			. ' WHERE id IN ( '. $cids .' )'
			;
			$db->setQuery( $query );
			if (!$db->query()) {
				JError::raiseWarning( 500, $db->getError() );
			}
		}
		$this->setMessage( JText::sprintf( 'Discount items removed', $n ) );
	}
}
