<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Utility class for creating different select lists
 *
 */
class JHTMLIpriceList
{
	function category( $name, $active = NULL, $javascript = NULL, $filter_sec = -1, $order = 'ipc.ordering', $size = 1, $sel_cat = 1, $wh=NULL )
	{
		$db =& JFactory::getDBO();

		$query = 'SELECT ipc.id AS value, ipc.name AS text'
		. ' FROM #__iprice_categories as ipc'
		. ' INNER JOIN #__iprice_sections AS ips ON ipc.secid = ips.id'
		. ' WHERE ipc.published = 1 and ips.published = 1 '. ($filter_sec>0 ? ' and ipc.secid = '.$filter_sec : '') 
		. ' ORDER BY ips.ordering, '. $order
		;
		$db->setQuery( $query );
		if ( $sel_cat ) {
			$categories[] = JHTML::_('select.option',  '0', '- '. JText::_( 'Select a Category' ) .' -' );
			$categories = array_merge( $categories, $db->loadObjectList() );
		} else {
			$categories = $db->loadObjectList();
		}

		$category = JHTML::_('select.genericlist',   $categories, $name, 'class="inputbox" size="'. $size .'" '. $javascript, 'value', 'text', $active );
		return $category;
	}


	function section( $name, $active = NULL, $javascript = NULL, $order = 'ordering', $size = 1, $sel_sec = 1 )
	{
		$db =& JFactory::getDBO();

		$query = 'SELECT id AS value, name AS text'
		. ' FROM #__iprice_sections'
		. ' WHERE published = 1 '
		. ' ORDER BY '. $order
		;
		$db->setQuery( $query );
		if ( $sel_sec ) {
			$sections[] = JHTML::_('select.option',  '0', '- '. JText::_( 'Select Section' ) .' -' );
			$sections = array_merge( $sections, $db->loadObjectList() );
		} else {
			$sections = $db->loadObjectList();
		}

		$section = JHTML::_('select.genericlist',   $sections, $name, 'class="inputbox" size="'. $size .'" '. $javascript, 'value', 'text', $active );
		return $section;
	}

	function discount( $name, $active = NULL, $javascript = NULL, $size = 1)
	{
		$db =& JFactory::getDBO();

		$query = 'SELECT id AS value, name AS text'
		. ' FROM #__iprice_discount'
		. ' WHERE published = 1 '
		;
		$db->setQuery( $query );
		$disc[] = JHTML::_('select.option',  '0', '- '. JText::_( 'Not set' ) .' -' );
		$disc[] = JHTML::_('select.option',  '-1', '- '. JText::_( 'No discount' ) .' -' );		
		$disc = array_merge( $disc, $db->loadObjectList() );
		$disc = JHTML::_('select.genericlist',   $disc, $name, 'class="inputbox" size="'. $size .'" '. $javascript, 'value', 'text', $active );
		return $disc;
	}

	function discount_type( $name, $active = NULL, $javascript = NULL, $size = 1)
	{
		$pos[] = JHTML::_('select.option',  '0', JText::_( 'by quantity' ));
		$pos[] = JHTML::_('select.option',  '1', JText::_( 'by amount' ));
		$position = JHTML::_('select.genericlist',   $pos, $name, 'class="inputbox" size="'. $size .'" '. $javascript, 'value', 'text', $active );
		return $position;
	}
	
	function discount_kind( $name, $active = NULL, $javascript = NULL, $size = 1)
	{
		$pos[] = JHTML::_('select.option',  '0', JText::_( 'percent' ));
		$pos[] = JHTML::_('select.option',  '1', JText::_( 'amount' ));
		$position = JHTML::_('select.genericlist',   $pos, $name, 'class="inputbox" size="'. $size .'" '. $javascript, 'value', 'text', $active );
		return $position;
	}
	
	function import_position( $name, $active = NULL, $javascript = NULL, $order = 'ordering', $size = 1)
	{
	
		$pos[] = JHTML::_('select.option',  '0', JText::_( 'In the beginning' ));
		$pos[] = JHTML::_('select.option',  '1', JText::_( 'In the end' ));
		$pos[] = JHTML::_('select.option',  '3', JText::_( 'Inside' ));
		$position = JHTML::_('select.genericlist',   $pos, $name, 'class="inputbox" size="'. $size .'" '. $javascript, 'value', 'text', $active );
		return $position;
	}
	
	function item_type( $name, $active = NULL, $javascript = NULL, $size = 1)
	{
	
		$pos[] = JHTML::_('select.option',  '0', JText::_( 'Item' ));
		$pos[] = JHTML::_('select.option',  '1', JText::_( 'Divider' ));
		$position = JHTML::_('select.genericlist',   $pos, $name, 'class="inputbox" size="'. $size .'" '. $javascript, 'value', 'text', $active );
		return $position;
	}
	
	function category_filter( $filter_sec = -1, $filter_catids = '', $name, $active = NULL, $javascript = NULL, $order = 'ipc.ordering', $size = 1, $sel_cat = 1, $wh=NULL )
	{
		$db =& JFactory::getDBO();
/*
		$query = 'SELECT id as value , name as text'
		. ' FROM #__iprice_categories';
		*/

		$query = 'SELECT ipc.id as key1, ips.id as key2,  ipc.id as value, ipc.name as text'
		. ' FROM #__iprice_categories as ipc'
		. ' INNER JOIN #__iprice_sections as ips ON ipc.secid = ips.id'
		. ' WHERE ipc.published = 1 and ips.published = 1 and ipc.secid = '.$filter_sec 
		. ($filter_catids ? ' and ipc.id in ('.$filter_catids.') ' : '')
		. ' ORDER BY ips.ordering, '. $order
		;

		$db->setQuery( $query );
		if ( $sel_cat ) {
			$categories[] = JHTML::_('select.option',  '0', '- '. JText::_( 'Select a Category' ) .' -' );
			$categories = array_merge( $categories, $db->loadObjectList() );
		} else {
			$categories = $db->loadObjectList();
		}

		$category = JHTML::_('select.genericlist',   $categories, $name, 'class="inputbox" size="'. $size .'" '. $javascript, 'value', 'text', $active );
		return $category;
	}


	function section_filter( $filter_sec = "",$name, $active = NULL, $javascript = NULL, $order = 'ordering', $size = 1, $sel_sec = 1 )
	{
		$db =& JFactory::getDBO();

		$query = 'SELECT id AS value, name AS text'
		. ' FROM #__iprice_sections'
		. ' WHERE published = 1 '. ($filter_sec ? ' and id in ('.$filter_sec.')' : '')
		. ' ORDER BY '. $order
		;
		$db->setQuery( $query );
		if ( $sel_sec ) {
			$sections[] = JHTML::_('select.option',  '0', '- '. JText::_( 'Select Section' ) .' -' );
			$sections = array_merge( $sections, $db->loadObjectList() );
		} else {
			$sections = $db->loadObjectList();
		}

		$section = JHTML::_('select.genericlist',   $sections, $name, 'class="inputbox" size="'. $size .'" '. $javascript, 'value', 'text', $active );
		return $section;
	}
	
	function order_templates()
	{
		$db =& JFactory::getDBO();

		$query = 'SELECT ipom.orderno as value, ipom.templatename as text'
		. ' FROM #__iprice_order_main as ipom'
		. ' WHERE ipom.istemplate = 1 '
		. ' ORDER BY ipom.orderno';

		$db->setQuery( $query );
		$tmpls[] = JHTML::_('select.option',  '0', '- '. JText::_( 'Select a template' ) .' -' );
		$tmpls = array_merge( $tmpls, $db->loadObjectList() );
		$tmpl = JHTML::_('select.genericlist',   $tmpls, 'orderno', 'class="inputbox" size="1"', 'value', 'text', NULL );
		return $tmpl;
	}
}

?>