<?php
/**
* @version		$ 1.2 2009-10$
* @package		Joomla
* @subpackage	IPricecalc
* @copyright	Copyright (C) 2009 LoT studio group. All rights reserved.
* @license		The commercial licence http://www.lot-studio.ru/license-ipricecalc
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );


class JTableIprice_importfield extends JTable
{
	var $id 		= null;

	var $name 		= null;
	var $position  	= 0;
	var $varname		= null;

	var $checked_out 	= 0;
	var $checked_out_time 	= 0;
	
	var $ordering 		= null;	
	var $published 		= 1;

// Admin by default
	var $owner		= 62;
	
	var $instext 	= null;
	
// internal variables

	var $_query = "";
	var $_querycount = "";
	var $_where	= "";
	var $_orderby	= "";
	
	/**
	* @param database A database connector object
	*/
	function __construct(&$db)
	{
		parent::__construct( '#__iprice_importfield', 'id', $db );
	}


	function check()
	{
		// check for valid name
		if (trim( $this->name ) == '') {
			$this->setError(JText::sprintf( 'must contain a title', JText::_( 'import field') ));
			return false;
		}

		return true;
	}
	
	function SetQuery($filter_state = "", $search = "",$filter_order = "", $filter_order_Dir = "", $whe = "")
	{
		$db =& JFactory::getDBO();
		
		$this->_query = 'SELECT * FROM #__iprice_importfield ';
						;
		$this->_querycount = 'SELECT COUNT(*) FROM #__iprice_importfield ';
		$wh = NULL;

		if ( $search ) {
			$wh[] = 'name LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$wh[] = 'published = 1';
			} else if ($filter_state == 'U' ) {
				$wh[] = 'published = 0';
			} else if ($filter_state == 'PP' ) {
				$wh[] = 'published = 1';
			}
		}
		
		if ( $whe ) {
		 	$wh[] = $whe;
		}
		
		$this->_where = ( count( $wh ) ? ' WHERE ' . implode( ' AND ', $wh ) : '' );
		
		if ($filter_order == 'ordering' || $filter_order == ''){
			$this->_orderby 	= ' ORDER BY ordering '.' '. $filter_order_Dir ;
		} else {
			$this->_orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir ;
		}
	}
	
	function GetOrderQuery()
	{
	  return 'SELECT ordering AS value, name AS text FROM #__iprice_importfield ORDER BY ordering';
	}
	
	function GetList($limitstart = 0, $limit = 0)
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_query . $this->_where . $this->_orderby, $limitstart, $limit);
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	function GetID($wh = null)
	{
		$db	=& $this->getDBO();
		$query = 'select id from #__iprice_importfield '.($wh!==null ? ' where  '.$wh : '');
		$db->setQuery($query);
		$rows = $db->loadResultArray();
		return $rows;
	}
	
	
	function GetCount()
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_querycount . $this->_where );
		$total = $db->loadResult();
		return $total;
	}
	
}
?>